

% Macro for Japanese 2byte Code.
define	NON	{0}
define	NOKANJI	{0}
define	EUC	{1}
define	JIS	{2}
define	SJIS	{3}
define	BINARY	{4}


define	TRUE	{-1}
define	FALSE	{0}

% If your slang-j's version in jed-j is after 0.3.2,
% you can use KANJI function name.
% but, that file's KANJI code must be the same SLang buffer KANJI code.
%define ̊֐()
%{
%   message("SLang-j 0.3.2 ȍ~ł͊֐Ɋg܂");
%}

define	set_default_kanji_fileio_code(code)
{
	if ((NOKANJI <= code) and (code <= BINARY))
		kfile_code = code;
}

define	get_default_kanji_fileio_code()
{
	return kfile_code;
}

define	rot_default_kanji_fileio_code()
{
	kfile_code++;
	if ((kfile_code < NOKANJI) or (BINARY < kfile_code))
		kfile_code = NOKANJI;
}

define	set_kanji_input_code(code)
{
	if ((NOKANJI <= code) and (code <= SJIS))
		kinput_code = code;
}

define	get_kanji_input_code()
{
	return kinput_code;
}

define	rot_kanji_input_code()
{
	kinput_code++;
	if ((kinput_code < NOKANJI) or (SJIS < kinput_code))
		kinput_code = NOKANJI;
}


define	set_kanji_display_code(code)
{
	if ((NOKANJI <= code) and (code <= BINARY))
		kdisplay_code = code;
}

define	get_kanji_display_code()
{
	return kdisplay_code;
}

define	rot_kanji_display_code()
{
	kdisplay_code++;
	if ((kdisplay_code < NOKANJI) or (BINARY < kdisplay_code))
		kdisplay_code = NOKANJI;
}



% returns
%	0x000: mark, space, kanji mark, kanji space.
%	0x001: number
%	0x002: alphabette
%	0x004: hankaku kana
%	0x010: 2byte number
%	0x020: 2byte alphabette
%	0x040: 2byte hiragana
%	0x080: 2byte katakana
%	0x100: 2byte kanji
define char_type(ch)
{
   variable mode = 0;

   if(('0' <= ch) and (ch <= '9'))
	 mode = 1;
   else if((('a' <= ch) and (ch <= 'z')) or (('A' <= ch) and (ch <= 'Z')))
	 mode = 2;
   else if((0xa1 <= ch) and (ch <= 0xe0))
	 mode = 4;
   else if(ch & 0xff00)		% KANJI
	 {
		if(ch == 0x815b)		% hiragana | katakana
		  mode = 0xc0;
		else if((0x824f <= ch) and (ch <= 0x8258))	% 2byte '0' - '9'
		  mode = 0x10;
		else if(((0x8260 <= ch) and (ch <= 0x8279)))	% 2byte alphabette
		  mode = 0x20;
		else if(((0x8281 <= ch) and (ch <= 0x829a)))	% 2byte alphabette
		  mode = 0x20;
		else if((0x82a0 <= ch) and (ch <= 0x82f1))		% hiragana
		  mode = 0x40;
		else if((0x8340 <= ch) and (ch <= 0x8396))		% katakana
		  mode = 0x80;
		else if(0x889f <= ch)		% kanji
		  mode = 0x100;
	 }
   
   return mode;
}


define jskip_non_word_chars(mode)	% forward: mode != 0	backward: mode == 0
{
   variable n = 0;
%   while(skip_non_word_chars(), jwhat_char() == 0x8140 )  % 0x8140 is 2byte KANJI white space.
   while(char_type(jwhat_char()) == 0)
	{
	   if(mode) {
		 !if(right(1)) break;
	   }
	   else {
		  !if (left(1)) break;
	   }
	   n++;
	}
   return n;
}
 
define jskip_word ()
{
   variable ch, mode;
%   while (jskip_non_word_chars(), eolp())
%     {
%		if (1 != right(1)) break;
%     }

   jskip_non_word_chars(1);
   
%   ch = jwhat_char();
   mode = char_type(jwhat_char());
   while(right(1))
	 {
		variable t;
		
		t = char_type(jwhat_char());
		!if(t & mode) return;
		if(t < mode) mode = t;
	 }
}

define jbskip_word ()
{
   variable ch, mode;

   !if(left(1)) return;
   jskip_non_word_chars(0);

   mode = char_type(jwhat_char());
   while(left(1))
	 {
		variable t;
		
		t = char_type(jwhat_char());
		!if(t & mode) {
		   right(1);
		   return;
		}
		if(t < mode) mode = t;
	 }
}

% flg is TRUE/FALSE
define	auto_file_code (flg)
{
	KfioAuto = flg;
	jed_fileauto = flg;
}

define print_jversion()
{
   variable kanji_major_version, kanji_minor_version, kanji_fix_version;
   variable slkanji_major_version, slkanji_minor_version, slkanji_fix_version;
   
   kanji_major_version = _jed_jversion / 10000;
   kanji_minor_version = (_jed_jversion / 100) - (kanji_major_version * 100);
   kanji_fix_version = _jed_jversion - (kanji_minor_version * 100);
   slkanji_major_version = _slang_jversion / 10000;
   slkanji_minor_version = (_slang_jversion / 100) - (slkanji_major_version * 100);
   slkanji_fix_version = _slang_jversion - (slkanji_minor_version * 100);
   message(Sprintf("Jed-j Version is %d.%d.%d\tSLang-j Version is %d.%d.%d",
		   kanji_major_version, kanji_minor_version, kanji_fix_version,
		   slkanji_major_version, slkanji_minor_version, slkanji_fix_version, 6));
}


% This function is the same function as "iskanji" function.
% define is_kanji (code)
% {
% 	if( SLang_code == SJIS ) {
% 		if((128 < code) and (code < 160))	return TRUE;
% 		if((223 < code) and (code < 253))	return TRUE;
% 	}
% 	else if (SLang_code == EUC) {
% 		if((160 < code) and (code < 255))	return TRUE;
% 	}
% 	else if (SLang_code == JIS) {
% 		if((32 < code) and (code < 127))	return TRUE;
% 	}
% 	return FALSE;
% }


